{{
PropXMM-D40.spin
Copyright (c) 2009 by John Steven Denson (jazzed)
See MIT license terms below
}}

{{
A 1 Propeller 2 COG SRAM random access demo. Propeller P16..31 are free for user.
-----------------------------------------------------------------------------------------
                                                                                       
Design assumes latched high address interface to 512K or 1MB SRAM ... just testing 512K now
D0..7 on P0..7
Should use 220 Ohm+ series resistors on SRAM D0..7
A0..5 on P8..13
A6..19 latched from P0..13 by P15 - non inverted
WE on P14 ALE on P15.
}}

con
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  PAUSE    = 100
  
obj
  s : "FullDuplexSerial"
    
pub main | n

  s.start(31,30,0,115200)
  waitcnt(clkfreq*2+cnt)
  
  s.str(string($d,$d,"PropXMM-D40 Demo",$d))
  address := $fffff
  
  cognew(@cog1, @command)
  cognew(@cog2, @command)
  
{ debug code
  cognew(@testcog, @command)
  repeat
'}

{ debug code    
  address := $80000
  repeat
    data := $88442211
    command := CMD_WR32
    repeat while command
    command := CMD_RD32
    repeat while command
    s.hex(data, 8)
    s.out(" ")
'}    

  repeat
'{ pattern test   
  'repeat
    'waitcnt(clkfreq/PAUSE+cnt)
    writelong(0, $33cc6699)
    result := readlong(0)
    s.hex(result, 8)
    s.out(" ")
'{
    'waitcnt(clkfreq/PAUSE+cnt)
    writelong(0, $12345678)
    result := readlong(0)
    s.hex(result, 8)
    s.out(" ")
'}      
'}

'{ incremental test
  'repeat
      
    'repeat n from 0 to 100 
      writelong(n | $80000, n)
    'repeat n from 0 to 100
      'waitcnt(clkfreq/PAUSE+cnt)
      result := readlong(n | $80000)
      s.hex(result, 8)
      s.out(" ")
    n+=4 
'}

DAT
testcog        org 0

  mov          msp,     par
  add          msp,     #4
  mov          map,     msp
  add          map,     #4
  mov          mdp,     map
  add          mdp,     #4
  'or           dira,    TESTPIN
  'andn         outa,    TESTPIN
  'mov          mda,     #0
  
testloop
  wrlong       testpat, mdp      
  wrlong       testadr, map
  'or           outa,    TESTPIN
  'rdlong       mval,    mda    ' par  
  'andn         outa,    TESTPIN
'{  
  mov          mval,    #CMD_WR32
  wrlong       mval,    par
testwait1
  rdlong       mval,    par wz
  if_nz jmp    #testwait1
'}
'{  
  mov          mval,    #CMD_RD32
  wrlong       mval,    par
testwait2
  rdlong       mval,    par wz
  if_nz jmp    #testwait2
  add          mda,     #1
  andn         mda,     #$1ff
'}  
  jmp          #testloop      

testpat        long $88442211
testadr        long $80000

msp     res 1
map     res 1
mdp     res 1
mtp     res 1
mcmd    res 1
mval    res 1
mda     res 1

       
con
  DATAMASK      = $000000ff
  ADDRANGE      = $000fffff        ' demultiplexed range 14+6 = 20 bits 
  ADDRMASK      = $00003fff        ' rising ALE latches 14 bits. 6 bits address direct connect. 
  ADR2MASK      = $00000300        ' rising ALE latches 14 bits. 6 bits address direct connect. 
  WEPIN         = 14
  CS_ALEPIN     = 15

  CMD_RD32      = 1
  CMD_WR32      = 2
  
var
  long  command
  long  signal
  long  address
  long  data

pub writelong(maddr, mdat)
  data := mdat
  address := maddr
  signal~
  command := CMD_WR32
  repeat while command

pub readlong(maddr)
  address := maddr
  signal~
  command := CMD_RD32
  repeat while command
  return data
  
dat
cog1           org       0

init
  or           dira,    datmask
  or           dira,    adrmask
  andn         dira,    cs_ale  ' CS_ALE has pullup 
  andn         outa,    cs_ale
  andn         dira,    wren    ' WEN has pullup ... set to output for write
  mov          sp,      par
  add          sp,      #4
  mov          ap,      sp
  add          ap,      #4
  mov          dp,      ap
  add          dp,      #4

  wrlong       ctrb,    sp      ' clear signal

  mov          frqa,    frqav
  mov          phsa,    phsav   ' 6 make sure phsa is set for each access
  mov          ctra,    ctrav   ' 7 enable counters for write strobe

  'or           dira,    TESTPIN
  'andn         outa,    TESTPIN
  
loop
  rdlong       cmd,     par wz
  if_z  jmp    #loop
  rdlong       addr,    ap
  test         cmd,     #CMD_RD32 wz
  if_nz jmp    #rd32
  test         cmd,     #CMD_WR32 wz
  if_nz rdlong val,     dp
  if_nz jmp    #wr32

done
  wrlong       dirb,    par     ' ctrb should be zero    
  jmp          #loop

'------------------------------------------------------------------------
' rd32 uses 2nd address cog 
' raw throughput is 5.0MB/s
'
rd32
  andn         dira,    cs_ale  ' start address cog  
  mov          outa,    addr    ' 0000.0000.0000.jihg.fedc.ba98.7654.3210 ... addr must be long aligned and not exceed 2MB
  ror          outa,    #6      ' 5432.1000.0000.0000.00ji.hgfe.dcba.9876 set A[6:19] to P[0:13]
  or           dira,    datmask ' address to output
  or           dira,    cs_ale  ' then latch bits ...  
  ror          outa,    #18     ' 0000.0000.0000.0000.0054.3210.0000.0000  address bits 0..5 on P8..12 ALE low     
  andn         dira,    datmask ' 7 data to input
  mov          val,     ina     'xxxxxxxxxxxxxxxxxxxxxxxxAAAAAAAA .
  ror          val,     #17 wc  'xxxxxxxxxAAAAAAAAxxxxxxxxxxxxxxx A0
  movi         val,     ina     'bBBBBBBBBAAAAAAAAxxxxxxxxxxxxxxx A0
  shr          val,     #8      '........bBBBBBBBBAAAAAAAAxxxxxxx A0
  movi         val,     ina     'cCCCCCCCCBBBBBBBBAAAAAAAAxxxxxxx A0
  shr          val,     #8      '........cCCCCCCCCBBBBBBBBAAAAAAA A0
  movi         val,     ina     'dDDDDDDDDCCCCCCCCBBBBBBBBAAAAAAA A0
  rcl          val,     #1      'DDDDDDDDCCCCCCCCBBBBBBBBAAAAAAAA A0
  'wrlong       val,     dp      ' normally for LMM mode this is not necessary since kernel runs in COG
  jmp   #done  'ret             ' 16 ticks required for LMM:  16*50 = 800ns or 5.0MB/s                         

'------------------------------------------------------------------------
' wr32 uses 2nd address cog and ctra pin for write strobe
' raw throughput is at least 4.2MB/s
'
wr32
  andn         dira,    cs_ale  ' start address cog  
  mov          outa,    addr    ' 0000.0000.0000.jihg.fedc.ba98.7654.3210 ... addr must be long aligned
  ror          outa,    #6      ' 5432.1000.0000.0000.00ji.hgfe.dcba.9876  shift for A[6..19]
  or           dira,    datmask ' address to output
  or           dira,    cs_ale  ' then latch bits ...  
  ror          outa,    #18     ' 0000.jihg.fedc.ba98.7654.3210.0000.0000  address bits 0..5 on P8..12 ALE low
  or           dira,    wren    ' 7 WE strobe pin to output
  movs         outa,    val     ' 8 movs is fine since only D0..7 are enabled for output
  ror          val,     #8      ' 9 next byte
  movs         outa,    val     ' 10 write byte
  ror          val,     #8      ' 11 next byte
  movs         outa,    val     ' 12 write byte
  ror          val,     #8      ' 13 next byte
  movs         outa,    val     ' 14 write byte
  'nop                           ' 15 ... not necessary?
  andn         dira,    wren    ' 15 WE to input
  jmp          #done    'ret    ' 16 800ns 5.0MB/s                               

TESTPIN        long     $10000000

sigdat         long     $4
adrmask        long     ADDRMASK
datmask        long     DATAMASK
cs_ale         long     1 << CS_ALEPIN
datasig        long     DATAMASK | 1 << CS_ALEPIN
wren           long     1 << WEPIN
wrensig        long     1 << WEPIN | 1 << CS_ALEPIN
ctrav          long     %00100_000 << 23 + WEPIN
frqav          long     $20000000
phsav          long     -1
val            res      1
addr           res      1
cmd            res      1
tp             res      1
sp             res      1
ap             res      1
dp             res      1

dat
cog2           org      0

  or           dira,    adrmask2

  waitpeq      cs_ale2, cs_ale2

addrloop
  test         cs_ale2, ina wc
  if_nc jmp    #addrloop
  'waitpeq      cs_ale2, cs_ale2
  mov          outa,    #0      ' make sure addr bits are clear
  mov          acnt,    #4                           
  nop                           ' delay for routines
  nop
  nop
addrinc
  add          outa,    #$100
  djnz         acnt,    #addrinc

  waitpne      cs_ale2, cs_ale2
  jmp          #addrloop                                                        

adrmask2       long     ADR2MASK
cs_ale2        long     |< CS_ALEPIN
sp2            res      1
acnt           res      1

{
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                  
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation    
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
}